package s18;
import java.util.Arrays;
import java.util.HashSet;
import java.util.PriorityQueue;
import java.util.Set;

public class Dijkstra {
  // ================================================
  record Vertex(int vid, long pty) implements Comparable<Vertex> {
    @Override public int compareTo(Vertex v) {
      return Long.compare(this.pty,  v.pty);
    }
  }
  // ================================================

  // POST : minDist[i] is the min distance from a to i
  //                      MAX_VALUE if i is not reachable, 0 for a
  //         parent[i] is the parent of i in the corresponding tree
  //                      -1 if i is not reachable, and for vertex a
  public static void dijkstra(WeightedDiGraph g, int a, 
                              long[] minDist, int[] parent) {
    return; // TODO - A COMPLETER...
  }

  /** returns all vertices in vid's strongly connected component */
  static Set<Integer> strongComponentOf(WeightedDiGraph g, int vid) {
    Set<Integer> res = new HashSet<>();
    // TODO - A COMPLETER...
    return res;
  }

  // ------------------------------------------------------------
  public static void main(String [] args) {
    int nVertices = 6; // int nEdges = 12;
    final int A=0, B=1, C=2, D=3, E=4, F=5;
    int[] srcs  = {A, A, A, B, B, D, D, D, D, E, F, F };
    int[] dsts  = {B, C, F, F, C, A, B, C, E, A, D, E };
    int[] costs = {12,6, 14,1, 7, 9, 3, 2, 4, 5, 10,11};

    WeightedDiGraph g = new WeightedDiGraph(nVertices, srcs, dsts, costs);
    System.out.println("Input Graph: " + g);

    int n = g.nbOfVertices();
    long[] minCost = new long[n];
    int [] parent  = new int [n];
    for (int a=0; a<n; a++) {
      dijkstra(g, a, minCost, parent);
      System.out.println("\nMinimal distances from " + a); 
      for (int i=0; i<minCost.length; i++) {
        String s = "to "+ i +":";
        if (minCost[i] == Long.MAX_VALUE) s += " unreachable";
        else s += " total " + minCost[i] + ", parent " + parent[i];
        System.out.println(s);
      }
    }
  }
}
